/**
 * Copyright © CENRA (2016)
 *
 * remi.clement@espaces-naturels.fr
 * 
 * This software is a multi-platform and portable application based on 
 * the scientifical toolbox to monitor wetlands. With this toolbox it’s 
 * possible to calculate indicators «RhoMéO» to monitor quality, 
 * fonctionalities and urban and agricultural pressures of wetlands. 
 * Indicators are calculated using naturalist data entered and/or imported,
 * and geographic data downloaded from a geographic server.
 * 
 * This software is governed by the CeCILL license under French law and
 * abiding by the rules of distribution of free software.  You can  use, 
 * modify and/ or redistribute the software under the terms of the CeCILL
 * license as circulated by CEA, CNRS and INRIA at the following URL
 * "http://www.cecill.info". 
 * 
 * As a counterpart to the access to the source code and  rights to copy,
 * modify and redistribute granted by the license, users are provided only
 * with a limited warranty  and the software's author,  the holder of the
 * economic rights,  and the successive licensors  have only  limited
 * liability. 
 * 
 * In this respect, the user's attention is drawn to the risks associated
 * with loading,  using,  modifying and/or developing or reproducing the
 * software by the user in light of its specific status of free software,
 * that may mean  that it is complicated to manipulate,  and  that  also
 * therefore means  that it is reserved for developers  and  experienced
 * professionals having in-depth computer knowledge. Users are therefore
 * encouraged to load and test the software's suitability as regards their
 * requirements in conditions enabling the security of their systems and/or 
 * data to be ensured and,  more generally, to use and operate it in the 
 * same conditions as regards security. 
 * 
 * The fact that you are presently reading this means that you have had
 * knowledge of the CeCILL license and that you accept its terms.
*/
package fr.cenra.rhomeo.fx.edition;

import fr.cenra.rhomeo.Rhomeo;
import fr.cenra.rhomeo.api.ui.StatementEditor;
import fr.cenra.rhomeo.api.ui.StatementEditorSpi;
import fr.cenra.rhomeo.core.RhomeoCore;
import fr.cenra.rhomeo.core.Session;
import fr.cenra.rhomeo.protocol.p02.list.PhysionomyFlore;
import fr.cenra.rhomeo.protocol.p02.FloreStatement;
import java.util.Arrays;
import java.util.List;
import javafx.beans.value.ObservableValue;
import javafx.collections.FXCollections;
import javafx.fxml.FXML;
import javafx.scene.control.ComboBox;
import javafx.util.StringConverter;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.context.annotation.Scope;
import org.springframework.stereotype.Component;

/**
 *
 * @author Alexis Manin (Geomatys)
 */
@Component
@Scope("prototype")
public class FXFloreEditor extends AbstractCustomStatementEditor<FloreStatement> {

    @FXML
    private ComboBox<PhysionomyFlore> uiPhysio;

    public FXFloreEditor() {
        super(FloreStatement.class);
        Rhomeo.loadFXML(this, FXFloreEditor.class);

        Rhomeo.initComboBox(uiPhysio, FXCollections.observableList(Arrays.asList(PhysionomyFlore.values())));
        uiPhysio.valueProperty().addListener(this::physionomyChanged);
        uiPhysio.setConverter(new StringConverter<PhysionomyFlore>() {
            @Override
            public String toString(PhysionomyFlore object) {
                if (object == null)
                    return null;
                return new StringBuilder(object.getCode()).append(" - ").append(object.getValue()).toString();
            }

            @Override
            public PhysionomyFlore fromString(String string) {
                if (string == null || (string = string.trim()).isEmpty()) {
                    return null;
                }

                return RhomeoCore.getByCode(PhysionomyFlore.class, string.split("\\s")[0]).orElse(null);
            }
        });
    }

    @Override
    protected void init() {
        super.init();
        if (uiStatementTable != null)
            uiStatementTable.sortColumns(Arrays.asList("cd_nom", "abundance"));
    }

    @Override
    protected String[] getFieldsToIgnore() {
        final String[] toIgnore = super.getFieldsToIgnore();
        final String[] overrided = new String[toIgnore.length + 2];
        overrided[0] = "physionomy";
        overrided[1] = "strate";
        System.arraycopy(toIgnore, 0, overrided, 2, toIgnore.length);
        return overrided;
    }

    @Override
    protected FloreStatement initStatement() throws ReflectiveOperationException {
        final FloreStatement data = super.initStatement();
        if (uiPhysio.getValue() instanceof PhysionomyFlore) {
            ((FloreStatement) data).setPhysionomy(uiPhysio.getValue().getCode());
        }
        return data;
    }

    /*
     * UI LISTENERS
     */
    private void physionomyChanged(final ObservableValue<? extends PhysionomyFlore> obs, final PhysionomyFlore oldPhysio, final PhysionomyFlore newPhysio) {
        final String newCode = newPhysio == null ? null : newPhysio.getCode();
        if (uiStatementTable == null || uiStatementTable.getItems() == null)
            return;
        
        for (int i = 0; i < uiStatementTable.getItems().size(); i++) {
            uiStatementTable.getItems().get(i).physionomyProperty().set(newCode);
        }
    }

    @Override
    protected void itemsChanged(final ObservableValue<? extends List> obs, final List<FloreStatement> oldItems, final List<FloreStatement> newItems) {
        super.itemsChanged(obs, oldItems, newItems);
        if (newItems != null && !newItems.isEmpty()) {
            uiPhysio.setValue(RhomeoCore.getByCode(PhysionomyFlore.class, newItems.get(0).getPhysionomy()).orElse(null));
        } else {
            uiPhysio.setValue(null);
        }
    }

    @Component
    public static class Spi implements StatementEditorSpi<FloreStatement> {

        @Autowired
        Session session;

        @Override
        public StatementEditor<FloreStatement> createEditor() {
            return session.createPrototype(FXFloreEditor.class);
        }

        @Override
        public Class<FloreStatement> getDataType() {
            return FloreStatement.class;
        }
    }
}
